package com.magnatune.eyecreate.companionformagnatune.adapters;

import android.content.Context;
import android.os.Build;
import android.os.Bundle;
import android.support.v4.app.FragmentManager;
import android.transition.AutoTransition;
import android.transition.Slide;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;

import com.magnatune.eyecreate.companionformagnatune.R;
import com.magnatune.eyecreate.companionformagnatune.fragments.ArtistFragment;
import com.magnatune.eyecreate.companionformagnatune.model.Artist;
import com.magnatune.eyecreate.companionformagnatune.viewholders.ArtistViewHolder;

import io.realm.RealmBasedRecyclerViewAdapter;
import io.realm.RealmResults;

public class ArtistsAdapter extends RealmBasedRecyclerViewAdapter<Artist,ArtistViewHolder> {

    FragmentManager fragmentManager;

    public ArtistsAdapter(Context context, RealmResults<Artist> realmResults, boolean automaticUpdate, boolean animateResults, boolean addSectionHeaders, String headerColumnName, FragmentManager fragmentManager) {
        super(context, realmResults, automaticUpdate, animateResults, addSectionHeaders, headerColumnName);
        this.fragmentManager = fragmentManager;
    }

    public ArtistsAdapter(Context context, RealmResults<Artist> realmResults, boolean automaticUpdate, boolean animateResults, boolean addSectionHeaders, String headerColumnName) {
        super(context, realmResults, automaticUpdate, animateResults, addSectionHeaders, headerColumnName);
    }

    @Override
    public ArtistViewHolder onCreateRealmViewHolder(ViewGroup viewGroup, int i) {
        View v = inflater.inflate(R.layout.listitem_artist,viewGroup,false);
        ArtistViewHolder holder = new ArtistViewHolder(v);
        return holder;
    }

    @Override
    public void onBindRealmViewHolder(final ArtistViewHolder artistViewHolder, final int i) {
        artistViewHolder.artistName.setText(realmResults.get(i).getArtistname());
        artistViewHolder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Bundle args = new Bundle();
                args.putString(ArtistFragment.ARG_ARTIST_NAME,realmResults.get(i).getArtistname());
                ArtistFragment fragment = new ArtistFragment();
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                    fragment.setEnterTransition(new Slide(Gravity.BOTTOM));
                    fragment.setExitTransition(new Slide(Gravity.BOTTOM));
                    fragment.setSharedElementEnterTransition(new AutoTransition());
                    fragment.setSharedElementReturnTransition(new AutoTransition());
                }
                fragment.setArguments(args);
                fragmentManager.beginTransaction()
                        .setCustomAnimations(R.anim.fragment_enter,R.anim.fragment_exit,R.anim.fragment_pop_enter,R.anim.fragment_pop_exit)
                        .addSharedElement(artistViewHolder.artistName, "artist_name")
                        .replace(R.id.fragment_holder, fragment, "artist")
                        .addToBackStack("artist")
                        .commit();
            }
        });
    }
}
