package com.magnatune.eyecreate.companionformagnatune.api;

import com.magnatune.eyecreate.companionformagnatune.model.xml.Album;
import com.magnatune.eyecreate.companionformagnatune.model.xml.Track;
import com.squareup.okhttp.ResponseBody;
import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.converters.basic.DateConverter;
import com.thoughtworks.xstream.io.xml.KXml2Driver;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.zip.GZIPInputStream;

import retrofit.Converter;

public class MagnatuneAlbumsConverter implements Converter<ResponseBody,ObjectInputStream> {
    @Override
    public ObjectInputStream convert(ResponseBody value) throws IOException {
        GZIPInputStream compressedStream = new GZIPInputStream(value.byteStream());
        XStream parser = new XStream(new KXml2Driver());
        parser.processAnnotations(Album.class);
        parser.processAnnotations(Track.class);
        parser.registerConverter(new DateConverter("yyyy-MM-dd",new String[]{}));
        parser.ignoreUnknownElements();
        ObjectInputStream objectStream = parser.createObjectInputStream(compressedStream);
        return objectStream;
    }
}
